### MAKEFILE PREAMBLE ###

TargetName   = rad_d
Makefile     = # "{TargetName}".make
ObjDir_ppc   = :

# Power Macintosh tools and default settings 

f77_ppc          = "{AbsoftTools}f77" -c 
f77_ppc_opts     = -N11 -C -g       -m     -f -W


# Object and resource files used for this build:

PPC_LIBS =  
 "{AbsoftLibraries}MRWE.o" 
 "{AbsoftLibraries}libfio.o" 
 "{AbsoftLibraries}libfmath.o" 
 "{AbsoftLibraries}initFApp.o"

PPC_OBJECTS = 
 "{ObjDir_ppc}inputp_d.o" 
 "{ObjDir_ppc}misc_d.o" 
 "{ObjDir_ppc}mov_d.o" 
 "{ObjDir_ppc}prob_d.o" 
 "{ObjDir_ppc}rad_d.o"

# Linkage rule

"{TargetName}"  {PPC_OBJECTS} {makefile}
 Delete -i "{TargetName}"
 Duplicate -y -r "{AbsoftLibraries}"mrwe.o "{TargetName}"
 lnk -O  -aliases "{AbsoftLibraries}"absoft_aliases 
    -o "{TargetName}" {PPC_OBJECTS} {PPC_LIBS} 
    -c 'Mrwe' -t APPL -sym on 
    "{AbsoftLibraries}absoft_init.o" 
    "{PPCLibraries}StdCRuntime.o" 
    "{SharedLibraries}StdCLib" 
    "{SharedLibraries}InterfaceLib"


# Compilation rules

"{ObjDir_ppc}inputp_d.o"  "inputp.f" {makefile} "rad.inc"
 {f77_ppc} {f77_ppc_opts} -o "{ObjDir_ppc}inputp_d.o" inputp.f

"{ObjDir_ppc}misc_d.o"  "misc.f" {makefile} "rad.inc"
 {f77_ppc} {f77_ppc_opts} -o "{ObjDir_ppc}misc_d.o" misc.f

"{ObjDir_ppc}mov_d.o"  "mov.f" {makefile} "rad.inc"
 {f77_ppc} {f77_ppc_opts} -o "{ObjDir_ppc}mov_d.o" mov.f

"{ObjDir_ppc}prob_d.o"  "prob.f" {makefile} "rad.inc"
 {f77_ppc} {f77_ppc_opts} -o "{ObjDir_ppc}prob_d.o" prob.f

"{ObjDir_ppc}rad_d.o"  "rad.f" {makefile} "rad.inc"
 {f77_ppc} {f77_ppc_opts} -o "{ObjDir_ppc}rad_d.o" rad.f

clean 
 Delete -i "{TargetName}" {PPC_OBJECTS}
